/*
 * MultiMAIL offline mail reader
 * 

   Written by Toth Istvan (stoty@vma.bme.hu)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef __BW_H
#define __BW_H

#include <stdio.h>
#include "internal.h"
#include "bluewave.h"

struct bodytype
{
	long pointer;
	long msgLength;
};

class bluewave : public specific_driver
{
private:
	mmail		*mm;
	char		*packetBaseName;
	char		*bwDirName;
	char		*packetName;
	INF_HEADER	*infoHeader;
	MIX_REC		*mixRecord;
	int			currentAreaID;
	int			currentLetter;
	
	FILE		*infFile;
	FILE		*mixFile;
	FILE		*ftiFile;
	FILE		*datFile;

	struct bodytype		**body;
	char		*bodyString;
	
	int			infoHeaderLen, infoAreainfoLen, mixStructLen, ftiStructLen;
	int			noOfMixRecs;

	int		areaSerial;
	int		ID;

	int 	uncompressPacket(const char *packetName);
	int 	initInf(const char *packetBaseName);
	int		readMixRec(const char *packetBaseName);
	int		initFti(const char	*packetBaseName);
	int		initDat(const char  *packetBaseName);
	
	int		init();
	int		cleanup();

	
public:
	bluewave(mmail *mmA);
	~bluewave();
	int getNoOfAreas();
	int resetAll();
	area_header *getNextArea();
	int selectArea(int ID);
	int getNoOfLetters();
	int resetLetters();
	letter_header *getNextLetter();
	char* getBody(int ID);
};

#endif  
