/*
 * MultiMAIL offline mail reader
 * 

   Written by Toth Istvan (stoty@vma.bme.hu)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef __RESOURCE_H
#define __RESOURCE_H

#include <stdio.h>
#include "mmail.h"

class mmail;

const int	homeDir = 1,
			mmHomeDir =2,
			bwPacketDir = 3,
			bwWorkDir = 4,
			bwUncompressCommand = 5,
			bwPacketName = 6,
			bwUserName = 7,
			bwBBSName = 8,
			bwSysOpName = 9,
			bwReplyFileName = 10,
			bwEchoTag=11,
			bwReplyDir = 12,
			bwLoginName = 13,
			bwAliasName = 14,	
			bwCompressCommand = 15,	
			bwUpWorkDir = 16,
			taglineChooseType = 17,
			sendConfirm = 18,
			editor = 19,
			mono = 20,
			bwSaveDir = 21,
			bwReadDir = 22,
			bwAddressBook = 23,			
			bwTaglineFile = 24;
class resource
{
	mmail *mm;
	const int   noOfResources = 24;  //edit

	FILE *configFile;

	struct resource_struct
	{
		char *name;	
		int	fromRc; // 0 if cannot be set
		char* value;
		int	(resource::*init)();
	} resourceData[noOfResources+1];
	
	int initHomeDir(); 
	int initBwWorkDir(); 
	int initBwPacketDir(); 
	int initBwUncompressCommand(); 
	int initBwReplyFileName(); 
	int initBwReplyDir(); 
	int initBwSaveDir(); 
	int initBwReadDir(); 
	int initBwCompressCommand(); 
	int initBwUpWorkDir(); 
	int initEditor(); 
	int initMmHomeDir();
	int initBwAddressBook();
	int initBwTaglineFile();

	int		initinit();
	int		parseConfig(FILE *);
			
public:

	resource(mmail *mmA);
	const char *const  get(const int ID);
	const char*	set(const int ID, const char *newValue);
	
};	
	  
#endif
